<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/23/2005 *
 * ===================                          Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-unlock_sponsor.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Unlock sponsor accounts                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenaccounts freigeben                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Check if admin has submitted form
if (isFormSent()) {
	// Does he have selected at least one sponsor?
	if (ifPostContainsSelections('id')) {
		// At least one entry selected
		foreach (postRequestParameter('id') as $id => $selected) {
			// Secure id number and init $content
			$content = array(
				'id'    => bigintval($id),
				'refid' => 0
			);

			// Load his personal data
			$result_main = SQL_QUERY_ESC("SELECT
	`id`, `gender`, `surname`, `family`, `email`, `remote_addr`,
	UNIX_TIMESTAMP(`sponsor_created`) AS `sponsor_created`,
	`points_amount`, `points_used`,
	(`points_amount` + `points_used`) AS `points`,
	`refid`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`status` IN('PENDING','UNCONFIRMED') AND
	`id`=%s
LIMIT 1",
			array($content['id']), __FILE__, __LINE__);

			/// Is there an entry?
			if (SQL_NUMROWS($result_main) == 1) {
				// Load data
				$content = SQL_FETCHARRAY($result_main);

				// Check for open payments and close them
				$result = SQL_QUERY_ESC("SELECT
	so.admin_id, so.pay_count,
	UNIX_TIMESTAMP(so.pay_ordered) AS `pay_ordered`,
	so.pay_status, sp.pay_name, sp.pay_rate, sp.pay_currency
FROM
	`{?_MYSQL_PREFIX?}_sponsor_orders` AS so
LEFT JOIN
	`{?_MYSQL_PREFIX?}_sponsor_paytypes` AS sp
ON
	sp.id=so.payment_id
WHERE
	so.sponsor_id=%s
ORDER BY
	sp.pay_name ASC",
					array($content['id']), __FILE__, __LINE__);
				if (!SQL_HASZERONUMS($result)) {
					// Payment does exist
					while ($content2 = SQL_FETCHARRAY($result)) {
						// Merge both arrays
						$content = merge_array($content, $content2);

						// Set default email
						$content['email'] = '{--SPONSOR_NO_ADMIN--}';
						if ($content['admin_id'] > 0) {
							// Load admin's email address for contact
							$content['email'] = getAdminEmail($content['admin_id']);
						} // END - if

						// Transfer data to array
						$data = array(
							'admin_id' => $content['email'],
							'order'    => ($content['pay_count'] * $content['pay_rate']) . ' ' . $content['pay_currency'],
							'stamp'    => generateDateTime($content['pay_ordered'], 2),
							'pname'    => $content['pay_name'],
						);

						// Load email template
						$content['message'] = loadEmailTemplate('sponsor_unlock_sponsor_pay', $data, $content['id']);
					}
				} else {
					// No payments found
					$content['message'] = '{--SPONSOR_NO_PAYMENTS_FOUND--}';
				}

				// Free memory
				SQL_FREERESULT($result);
			} else {
				// Not found
				loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_SPONSOR_ACCOUNT_404_ALREADY_CONFIRMED', $content['id']));
				return;
			}

			// Free memory
			SQL_FREERESULT($result_main);

			// Unlock sponsor account
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_sponsor_data`
SET
	`status`='CONFIRMED'
WHERE
	`id`=%s AND
	`status` IN('PENDING','UNCONFIRMED')
LIMIT 1",
			array($content['id']), __FILE__, __LINE__);

			// Update, if applyable, referal count and points
			if ((isValidUserId($content['refid'])) && ($content['refid'] != $content['id'])) {
				// Update referal account
				SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_sponsor_data`
SET
	`points_amount`=`points_amount`+{?sponsor_ref_points?}, `ref_count`=`ref_count`+1
WHERE
	`id`=%s
LIMIT 1",
					array(bigintval($content['refid'])), __FILE__, __LINE__);

				// Whas that update fine?
				if (SQL_AFFECTEDROWS() == 1) {
					// Load referal's data
					$result = SQL_QUERY_ESC("SELECT
	`id`, `gender`, `surname`, `family`, `email`,
	(`points_amount` - `points_used`) AS points,
	`receive_warnings`, `ref_count` AS refs
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`id`=%s
LIMIT 1",
					array(bigintval($content['refid'])), __FILE__, __LINE__);
					$REFERAL = SQL_FETCHARRAY($result);

					// Send warnings out?
					if ($REFERAL['receive_warnings'] == 'Y') {
						// Send notification to referal
						$REFERAL_MSG = loadEmailTemplate('sponsor_ref_notify', $REFERAL);
						sendEmail($REFERAL['email'], '{--SPONSOR_REFERAL_NOTIFY_SUBJECT--}', $REFERAL_MSG);
					} // END - if

					// Free memory
					SQL_FREERESULT($result);
				} // END - if
			} // END - if

			// So let's send the email away
			$message = loadEmailTemplate('sponsor_unlocked', $content);
			sendEmail($content['email'], '{--SPONSOR_UNLOCKED_SUBJECT--}', $message);
		} // END - foreach
	} else {
		// Nothing selected
		loadTemplate('admin_settings_saved', false, '{--ADMIN_SPONSOR_NONE_SELECTED_UNLOCK--}');
	}
} // END - if

// Begin listing of all pending sponsor accounts
$result = SQL_QUERY("SELECT
	`id`, `gender`, `surname`, `family`, `email`, `remote_addr`,
	UNIX_TIMESTAMP(`sponsor_created`) AS `sponsor_created`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`status` IN('PENDING','UNCONFIRMED')
ORDER BY
	`id`", __FILE__, __LINE__);

if (!SQL_HASZERONUMS($result)) {
	// Entries found so let's list them!
	$OUT = '';
	while ($content = SQL_FETCHARRAY($result)) {
		// Translate some data
		$content['sponsor_created'] = generateDateTime($content['sponsor_created'], 2);

		// Load row template and switch colors
		$OUT .= loadTemplate('admin_unlock_sponsor_row', true, $content);
	} // END - while

	// Load template
	loadTemplate('admin_unlock_sponsor', false, $OUT);
} else {
	// No pending accounts found
	loadTemplate('admin_settings_saved', false, '{--ADMIN_SPONSOR_NONE_PENDING--}');
}

// Free memory
SQL_FREERESULT($result);

// [EOF]
?>
