<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/25/2003 *
 * ===================                          Last change: 04/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : install.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Installation script.                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Installationsscript.                             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// XDEBUG call
//* DEBUG: */ xdebug_start_trace();

// Load security system
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Tell every module / require file we are installing
$GLOBALS['mailer_installing'] = true;

// Set CSS variable for "normal mode"
$GLOBALS['output_mode'] = '0';

// Set module
$GLOBALS['module'] = 'install';

// Load config file
require('inc/config-global.php');

// Set content type
setContentType('text/html');

// Reload page to page=welcome when it is not specified
if (!isGetRequestParameterSet('page')) {
	redirectToUrl('install.php?page=welcome');
} // END - if

// Set username
setUsername('{--USERNAME_INSTALLER--}');

// Already installed?
if ((isInstalled()) && (getRequestParameter('page' != 'finished'))) {
	// Add fatal message
	addFatalMessage(__FILE__, __LINE__, '{--ALREADY_INSTALLED--}');
} // END - if

// Load header here
loadIncludeOnce('inc/header.php');

// Handle fatal errors
runFilterChain('handle_fatal_errors');

// Here start's our installtion stuff
loadIncludeOnce('inc/install-inc.php');

// Load main installation table
loadTemplate('install_main', false, getInstallerContent());

// Footer
loadIncludeOnce('inc/footer.php');

// [EOF]
?>
